<template>
  <q-layout-header :reveal="true">
    <q-toolbar :inverted="$q.theme === 'ios'">
      <q-btn
        flat
        round
        icon="menu"
        :aria-label="$t('header.menuAria')"
        @click="toggleSidebar"
      />
      <q-toolbar-title>
        <span v-html="$t('header.title')"/>
        <span v-if="isAuthorized" slot="subtitle" v-html="$t('header.subTitle', {user: login})"/>
      </q-toolbar-title>
      <q-btn
        flat
        size="md"
        v-if="!isAuthorized"
        :label="$t(`header.actions.signIn`)"
        @click="showSignInModal"
      />
      <q-btn
        color="red"
        size="md"
        v-if="isAuthorized"
        :label="$t(`header.actions.signOut`)"
        @click="signOut"
      />
    </q-toolbar>
  </q-layout-header>
</template>

<script>
import { mapState } from 'vuex'

export default {
  name: 'HeaderComponent',
  methods: {
    navigateTo(url) {
      this.$router.push(url)
    },
    toggleSidebar() {
      this.$store.commit('layout/isSidebarActive', !this.isSidebarActive)
    },
    showSignInModal() {
      this.$store.commit('user/isSignInModalActive', !this.isSignInModalActive)
    },
    signOut() {
      this.$store.commit('user/signOut')
    },
  },
  computed: {
    ...mapState('user', [
      'isAuthorized',
      'isSignInModalActive',
      'login',
    ]),
    ...mapState('layout', [
      'isSidebarActive',
    ]),
  },
}
</script>
